
【M88 の履歴】
	M88_221 031104	・80SR対応のバグを修正(Thanks for arearea氏)
			・全画面モードに切り替えると不具合が出ることがあった
			　のを修正。(マルチスクリーン環境で挙動が変わります)
	     +a 031111	・テキスト画面が崩れるバグを修正

	M88_220 030929	・arearea 氏の 80SR 対応パッチの取り込み

        M88_219 030513	・FM音源の再現性向上
			・Sound Dump が機能しなくなっていたのを修正
			・モジュールを使ったとき、モジュールのConfigがでて
			  こない場合があったバグを修正
			・等
			(fb5c4a9e)

	     +a	030519	・ジョイパッドのボタン入れ替えが動くようになった？
			・CRTC初期化時のテキストカラーを黒から白に修正
			・ADPCM/Rhythmがボリュームの設定によって鳴らなくなる
			  問題を修正
			(7a16d1ad)

	M88_217	020602	・サンプリングレート変換器を改良(重くなりました)
			(e15f89fc)
			
	M88_216	??????	・ROMEO 仮対応(要 PCIDEBUG.DLL)
			・その他については忘れました
			  結構重要なバグが直ってなかったりしますが
			  世の中そーゆーものです
			
	M88_215 000110	・全画面時 vsync と同期するようにした
			・スナップショットファイルを圧縮するようにした
			(d084b46b/c0e02951)
			
	M88_214 991228	・全角・半角キーを使えるようにした
			・拡張ヘッダを含むリズム音の WAV ファイルに対応
			・拡張モジュールの仕様変更
			・V1 モード時のウェイトがあまり効いてなかったのを修正 
			・状態復帰時に テキスト画面が1行ずれることがある
			・W2K で落ちることがあるバグを修正
			・リズム音源 mute 時に発音が行われる？バグを修正
			・exe ファイル改変チェックを組み込む
			(8b4cc728/76e390c4)
			
	     +a 991230	・音源系の旧モジュールが使用できないバグを修正
	     		(407f4351/cd0e2d95)
			
	M88_213 990925	・OPNA で x1, x8 モードのデータ構造の違いを再現
			・スクリーンショットにショートカットキーを割り当てた
			・スクリーンショットのファイル名を自動生成可能に
			
	M88_212	990826	・チャンネル選択機能を追加
			・外部デバイスに対応
			・OPNA で DRAM モードを変更した際にリミットレジスタを
			  切り替えるようにする
			・割り込みマスクポートで割り込みを許可した際の
			  割り込みチェックのタイミングを修正
	     +a 990828	・FDC クラスで領域侵害があったのを修正
			  
	M88_211	990816	・スナップショット対応
	
	M88_210	990724	・FM 音源の処理を改良
			・N80 モード周りの改良 (arearea 氏に感謝!)
			・日付設定に関する問題を修正
			
	M88_209	990715	・DirectDraw モードで領域外アクセスがあったのを除去
			・CSM 再生の改善
			・録音関係の修正
			・95 でメモリ監視がまともに表示できなくなったのを修正
			
	M88_208	990711	・SSG 音源の書き直し
			・waveOut 時のバッファを増やす
			・録音関係の修正
			・95 で waveOut を使うとたまにロックするのを修正
			・画面切替え時に音の再生を止めるようにする
			・ALU 選択時に GVRAM 上のプログラムを実行すると
			  強制終了されるバグを修正
			
	M88_207 990704	・音声の高精度合成をサポート
			・FM 音源を切り離せるようにする
			・DirectSound を使わない再生モードを追加．
	
	M88_206	990626	・Memory/Code で 6000-7fff が切り替わらないバグを修正
			・N80 Mode 追加(要 8001mk2 の BIOS)
			・FM 音源の各 OP 出力にフィルタを掛けてみた
	     +a 990626	・N80 モード以外を一度動かすと，N80 モードでカラー
	      		  モードが機能しないバグを修正
	     +b 990627	・N80 カラーモードで，テキストの色に支障が出る
	      		  バグを修正
	
	M88_205 990620	・Port AA の初期値を修正.
			・PCG-8100 系フォント書き換え機能の復活.
			・デバッグ用のツールを追加．
			
	M88_204 990424	・マウス使用時にウィンドウが動いてしまうことがある
			  バグを修正.
			・全画面からウィンドウ表示に切り替えた後すぐに
			  全画面表示にするとタスクバーが表示されてしまう
			  ことがあるバグを修正.
			・CRTC のアトリビュート展開のバグを修正(?).
			・OPNA 110H によるステータスマスクの修正.
			・FM 音源のライト(?)バージョンの実装.
			
	M88_203 990418  ・アトリビュート展開が画面の下から行っていたのを
			  上から行うように修正．
			・PCM 合成省略時にもバッファを進めておくことにした．
			・688 バイト未満のディスクイメージを
			  読み込めないバグを修正．
			・ADPCM の RAM モード変更時にアドレスレジスタを
			  更新するようにした．
			・DDCB 系未定義命令を実装 (x86 版 Z80 エンジンのみ)．
			・CP 命令における未定義フラグの挙動を修正．
			・別のドライブで開いているディスクイメージを開くと
			  空ディスク作成ダイアログが開いてしまうバグを修正．
			
	M88_202 990411	R レジスタのバグを修正.
			BIOS のパスを指定可能に(M88.ini にて BIOSPath=で指定).
			2D/2DD モード切替え時のトラック位置に対応.
			テキスト画面の上線下線属性実装.
			空ディスク作成機能実装.
	
	M88_201 990407  OPNA(0xa8): 未使用時に完全に殺すようにする.
			FDC: EOT 条件の変更.
			画面: モード切替え時に例外が出る場合があるのを修正.
			マウス: ジョイスティックモード対応.
			ジョイパッド: ボタン入力が誤っていたのを修正

	M88_200	990406	新しく作り直した．
			「インターレース表示」機能実装．
			白黒モードにおける，テキスト反転属性による
			グラフィックの反転に対応.
			CPU の切替え方法を改善．
			ディスクイメージの検証方法を変更.
			連結ディスクイメージの書き込みに対応．
			ディスクランプの実装．
			2DD/2HD に対応 (要:2HD 機種の ROM)．
			FDC の挙動を改善．
			ReadDiag のダミーデータ作成，
			キーボードの種類を「設定」ダイアログで選択可能に．
			ステータスバーの実装．
			起動時エラーの実装．
			辞書 ROM 対応．
			未実装：PCG, 新ディスクイメージの作成，上線下線など.
			
	M88_19	981017	メモリウェイト実装。
			DirectSound 廻りの改善。
			LFO を実装した。
			ADPCM のレジスタの初期設定に関するエンバグを修正。
			ハードウェア LFO に対応。
			表示モードの変更に失敗したときに落ちるバグを修正。
			ディジタルパレットモードに対応。
			全画面表示を 640x480 モードで表示できるようにした。
			ジョイスティックの使用を選択できるようにした。
			タイミング計測の手段を選択できるようにした。
	    19a 981018	マスク時の OPN 割り込みが捨てられてしまう問題を修正。
			OPN(A8h) の割り込みマスクの初期状態を修正。
			合成周波数を変更した際 LFO 周波数が変わるバグを修正。
			SSG の再生がおかしくなることがあったのを修正。
	    19b 981102	Visual C++ 6.0 導入記念。
	    		Port32 による FM 割り込み再発生現象に対応。
	    		FDD からの起動スイッチを追加。
	    		パッドの感度設定を追加。
	    19c 981108	commctrl 4.00 に対応。
	    19d 990115	ADPCM の線形補完（未完成）
	    		F12 キーを COPY キーとして使えるようにした
	    		音量を OFF にできるようにした
	    19e 990228	ADPCM ループ時に音が変化するバグを修正.
	        	ADPCM 再生時にたまに音が小さくなるバグを修正.
			
	M88_18	980918	ジョイスティックに対応。
			『リセットで確認時』に終了時にも確認をとるようにした。
			ディップスイッチ設定に対応。
			表示できるテキスト画面のモードを増やす。
			CMD SING を無効にできるようにした。
			画像表示方法を従来の方法に戻した。
			(HiColor 以上の)窓での DirectDraw のサポートを中止。
	
	M88_17	980913	全画面モード追加。
			全画面、窓画面とも DirectDraw に対応。
			設定ダイアログの改善。
			音量調整機能追加。
			V1H モードを追加（速度は変わりませんが...)
			音再生アルゴリズムを改良。
	    17a 980915	95 の多色環境で全画面切り替えができない問題を修正。
	    		音量調節で一部の調整がうまく行かない問題を修正。
	    		VBLANK 開始時の画像を表示するようにした。
			
	M88_16	980823	FM 音源の作り直し。
			方向キーのテンキー割り当て時に、方向キーの入力を止めた。
			BEEP-Sound の発声がうまくなかったのを修正。
			
	M88_15	980730	98 系キーボードに対応かも。
			NT の 1 CPU 環境で反応が鈍くなる問題を修正。
			カレンダ時計を uPD4990 互換に。時刻設定も可能。
			音無しモードで OPN 割り込みがかからない問題を修正。
	    15a	980807	テキストメモリを吐き出すコードが残っていたのを消す。
	    		拡張 RAM バンクから正常に読めない場合がある問題を修正。
	    		割り込み発生条件をすこし変える。
	    		テキスト表示開始条件を緩くする。
	    		ADPCM 再生開始位置を START ADDRESS にする。
			
	M88_14	980724	キーボード関係の処理を書きなおす。
			FM 割り込みマスクが即座に反映されない問題を修正。
			リズム音色を読みこむ際、データサイズを見るように変更。
			方向キーをテンキーに割り当てるオプションを追加。
	    14a 980725	キーボードの周りでデッドロックがあったのを修正？
			
	M88_13	980720	SSG(PSG) の生成方法を変更。
			BEEP への仮対応。
			ノーウェイト時に Port6E が正常に機能しないバグを修正。
			DMA モードが verify でもテキスト表示するように変更。
			Sound=x を追加。
			FM:CSM モード時の KEY OFF に関する問題を修正。
			FM:FM 6 音に対応。
			ADPCM にも対応 (直接モード、PAN 等未対応)。
	    13a 980721	ADPCM PAN 対応。
			リズム音対応(リズム音を録音した wav ファイルが必要です)
			ADPCM メモリをダンプするコードが残っていたのを消す。
			OPN タイマー、割り込み周りの見なおし。
			最適化方針を変えてみる。
	    13b 980722	タイマーの更なる修正。
	    		ステータスフラグのバグを修正。
	    		OPNA 拡張を有効にするか選択できるようにする。
	    		ADPCM メモリの読み出しアドレスがずれていたのを修正。
	
	M88_12	980712	PSG のエンベロープに一部誤りがあったのを修正。
			VSYNC 割り込みのタイミング修正。
			出力レベルが高いとき音が割れないように修正。
			クロック単位で CPU を切り替えるモードを追加。
			FM 割り込み周りの論理の見なおし。
			P88SR 式マルチディスクイメージに対応。
			46H/47H への出力も OPN が受ける問題を修正。
	    12a	980713	プリスケーラの設定に問題があったのを修正。
			FM 音源ユニットを最新版に更新。
	
	M88_11	980707	M.A.M.E.の FM 音源ユニット(佐藤達之氏作)を組み込む。
			ADC/SBC HL 系のフラグ(ZF)に関するバグを修正。
			OPN のステータスビットを改変（仮）。
			最適化の方針をサイズ優先に変更。
	
	M88_10	980630	P88SR イメージで、単倍を識別するようにした。
			FDC 操作の際、タイミングによっては止まるバグを修正？
			テキストにパレットを反映する条件に関するバグを修正。
			日本語版以外の Windows で起動しない問題対策をした。
			8 MHz 識別ポートに対応。
	
	M88_09	980622	R レジスタまわりのバグ修正。
			FDC のマルチトラック命令のバグ修正
			BASIC モードの設定が起動時に反映されないバグを修正。
			WriteID で、単倍識別フラグが逆になっていたのを修正。
			マルチレンクフォーマット(確認済:2x9+1x1)に対応。
	
	M88_08	980615	P88SR イメージで WriteID に対応。
			空ディスクイメージ作成機能追加。
			Main<->Sub 間 PIO の初期化に関するバグ修正。
			DirectX 5 における音ループ問題を修正？
			15KHz モニターモード、PCG 表示機能(仮)、
			ノーウェイトモード追加。
	
	M88_07  980607  PSG 用の DirectSoundBuffer がなぜか Static Buffer に
	                なっていたのを Streaming buffer に変更した。
	                「設定」ダイアログの追加。
	                
	M88_06	980606	CRTC テキスト表示停止条件を追加
			port e4 bit 3 が有効になってなかったのを修正
			FDC の Deleted 系コマンドに対応
			拡張 RAM を追加
			PSG のトーン周波数が Nyquist 周波数を超えたとき
			発声しないようにした
	
	M88_05	980531	第２水準漢字 ROM がうまく読めなかったのを修正
			VRTC 割り込み回りの処理を改善
	
	M88_04	980529	サウンド周りの改善
			割り込み方式の変更、FDC 周りでとまる可能性を低減
	
	M88_03  980528  P88SR 形式の ROM を使用可能に
	
	M88_02	980527	一般公開
			最適化を Pentium Pro から Blend に変更
			SUB 側が MAIN 側を待っている時は処理しないようにする
			グラフィック周りのバグを解消
			PSG 鳴らしてみる
	
	M88_01	980515	限定公開


【連絡先】
	e-mail:	cisc@retropc.net
	www:    http://www.retropc.net/cisc/m88/
